#include <iostream>
#include <memory>

struct animal {
	virtual void speak() const {
		std::cout << "<generic animal noise>\n";
	}

	virtual ~animal() = default;
};

struct dog : animal {
	// try erasing const and/or override
	void speak() const override {
		std::cout << "Whoof!\n";
	}
};

struct cat : animal {
	void speak() const override {
		std::cout << "Meow!\n";
	}
};

struct nonvirt {
	int x;
	void foo() {}
};

struct virt {
	int x;
	virtual void foo() {}
};

int main() {
	dog fido;
	fido.speak();

	animal& ref = fido;
	ref.speak();

	std::cout << sizeof(nonvirt) << ' '
	          << sizeof(virt) << '\n';
}
