#include <iostream>

struct base {
	virtual void tell() const {
		std::cout << "I am base.\n";
	}

	base() {
		std::cout << "base constructor: ";
		tell();
	}

	void non_virtual() {
		std::cout << "base non-virtual function: ";
		tell();
	}

	~base() {
		std::cout << "base destructor: ";
		tell();
	}
};

struct derived : base {
	void tell() const override {
		std::cout << "I am derived.\n";
	}

	derived() {
		std::cout << "derived constructor: ";
		tell();
	}

	~derived() {
		std::cout << "derived destructor: ";
		tell();
	}
};

int main() {
	derived d;
	std::cout << "---\n";
	d.non_virtual();

	std::cout << "---\n";

	base& ref = d;
	ref.non_virtual();
	std::cout << "---\n";
}
